<script lang="ts" setup>
import { useReceiptStore } from '@/stores/receipt'
import type { ReceiptItem } from '@/types/RecieptItem'

import { computed, ref } from 'vue'
import type { VSheet } from 'vuetify/components'

const receiptStore = useReceiptStore()

const div = ref<HTMLElement | null>(null)

const scrollToBottom = () => {
  div.value!.scrollTo(0, div.value!.scrollHeight)
}

const props = withDefaults(
  defineProps<{
    editable: boolean
  }>(),
  { editable: true }
)
defineExpose({
  scrollToBottom
})
</script>

<template>
  <div class="overflow-auto" ref="div">
    <v-sheet max-width="700" min-width="300" height="350" elevation="3">
      <v-table>
        <thead>
          <tr>
            <th>id</th>
            <th>name</th>
            <th>category</th>
            <th>sweet</th>
            <th>price</th>
            <th>qty</th>
            <th>total</th>
            <th></th>
          </tr>
        </thead>
        <tbody>
          <tr
            v-for="(item, index) of receiptStore.receiptItems"
            :key="item.id"
            :style="{ backgroundColor: index % 2 === 0 ? '#eeeeee' : '#ffffff' }"
          >
            <td>{{ index + 1 }}</td>
            <td class="truncate">{{ item.name }}</td>
            <td>{{ item.category }}</td>
            <td>{{ item.sweet }}</td>
            <td>{{ item.price }}</td>
            <td>
              <v-btn
                color="gray"
                icon="mdi-minus"
                density="compact"
                size="s"
                @click="receiptStore.decUnitOfReceiptItem(item)"
              ></v-btn>
              {{ item.qty }}
              <v-btn
                color="gray"
                icon="mdi-plus"
                density="compact"
                size="s"
                @click="receiptStore.incUnitOfReceiptItem(item)"
              ></v-btn>
            </td>
            <td>{{ item.price * item.qty }}</td>
            <td>
              <v-btn
                color="red"
                icon="mdi-delete"
                density="compact"
                size="s"
                @click="
                  () => {
                    receiptStore.removeItem(item)
                  }
                "
              ></v-btn>
            </td>
          </tr>
        </tbody>
      </v-table>
    </v-sheet>
  </div>
</template>

<style scoped>
.truncate {
  max-width: 120px; /* Adjust the maximum width as needed */
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
}
</style>
